# Release notes for the SystemC AMS regression test suite

## Contents

  1. Supported platforms
  2. Known limitations

## 1. Supported platforms

This release is supported on the following platform combinations for
which it has been tested:
                
  * 64-bit Linux (x86_64)
    (RedHat Enterprise Linux 7; RedHat Enterprise Linux 8; Debian 10)
     - GNU C++ compiler versions gcc-8, gcc-9, gcc-11, gcc-14
     - Clang C++ compiler versions clang-14, clang-16

  * Microsoft Windows
    (Windows 10 Enterprise)
     - Microsoft Visual Studio 2015 (14.0) (Win32 and x64)
     - Microsoft Visual Studio 2019 (16.0) (Win32 and x64)
     - Microsoft Visual Studio 2022 (17.0) (Win32 and x64)
     - GNU C++ MinGW-w64 compiler versions gcc-9, gcc-11
     - Clang C++ MinGW-w64 compiler versions clang-16

## 2. Known limitations

Here is a list of known limitations in this release:

  * Not all options of the verify-ams.pl script are fully functional.

  * The regression test suite currently covers about 80% of the
    SystemC AMS language reference manual defined in IEEE Std. 1666.1. 
    Aim is to get this number up to 100%.

  * The organization of the tests in the test suite can (and must) be
    improved.

  * Checking of analog waveforms compared to reference waveforms is 
    difficult caused by potential rounding errors and accuracy 
    of the analog signals represented by a double data type.

